{% extends "siswa/userbase.html.twig" %}
{% import "macros/form.html.twig" as f %}

{% block body %}



    {% block moreCss %}
    {% endblock %}
    {% embed 'siswa/secondaryBar.html.twig' %}
        {% block title %}

        {% endblock %}

        {% block menuBar %}

            <a id="kumpulkan" href="#" style="border-radius: 50px; padding: 0.5em 1em" class="b-accent f08 text-white"
               data-toggle="modal"
               data-target="#modalKumpulkan">Kumpulkan</a>
            <div id="bottomBar" class="flex-fill d-none">
                <p id="countdown_p" class="mb-0 text-center p-2 f08 w-100"
                   style="border-radius: 10px; border: 1px solid var(--primaryColor)">Sisa Waktu: <span
                            class="countdown t-primary"
                    ></span></p>
                <div class="d-flex pt-3  w-100 align-items-center">
                    <div id="numberInPage" class="scrolling-wrapper mr-1">
                    </div>

                    <a data-toggle="modal" data-target="#allSoal"><i class="mdi mdi-apps f14"></i></a>
                </div>
            </div>
        {% endblock %}

    {% endembed %}

    {#    Tagihan#}
    <div class="tab-content mt-3" id="content">
    </div>

    <!-- Modal -->
    <div class="modal fade" id="allSoal" tabindex="-1" role="dialog" aria-labelledby="allSoal"
         aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">

                <div class="modal-body">
                    <a data-dismiss="modal" aria-label="Close"><i class="mdi mdi-close f14 d-block text-right"></i></a>

                    <p class="f18 text-center mt-3">Sisa Waktu</p>
                    <p style="border-radius: 50px; text-align: center; border: 1px solid var(--primaryColor); color: var(--primaryColor); "
                       class="f16 "><span class="countdown"></span></p>

                    <p class="f16 text-center mt-5">Daftar Soal</p>
                    <div class="mt-1">

                        <div id="numberInModal" class="text-center"></div>
                    </div>

                    <div class="modal-footer">
                        <a class="bt-accent w-100 f10" data-dismiss="modal" aria-label="Close" data-toggle="modal"
                           data-target="#modalKumpulkan">Kumpulkan</a>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="modalKumpulkan" tabindex="-1" role="dialog" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-body p-3 text-center">
                    {#    KETERANGAN PAGE#}

                    <p>Sisa Waktu</p>
                    <span class="countdown t-primary font-weight-bold">00:00:00</span>
                    <p>Apakah kamu yakin dengan jawabanmu? Setelah dikumpulkan kamu tidak bisa mengubah jawaban kamu</p>
                    <p class="div-color d-none" id="unResolved"></p>

                    <a id="finishSession" class="bt-primary d-block mt-5">Kumpulkan</a>
                    <a class="bt-outline-primary d-block mt-3" data-dismiss="modal" aria-label="Close">Kembali</a>
                </div>

            </div>
        </div>
    </div>

    <div class="space-25h"></div>
{% endblock %}

{% block JSMore %}
    <script src="{{ asset('js/formatter.js') }}"></script>

    <script>
        let asuTime = new Date();
        let notAnswered = [];
        let interValCountDown;
        let timeOut = false;

        Array.prototype.remove = function () {
            var what, a = arguments, L = a.length, ax;
            while (L && this.length) {
                what = a[--L];
                while ((ax = this.indexOf(what)) !== -1) {
                    this.splice(ax, 1);
                }
            }
            return this;
        };

        function saveSuccess(data) {
            // console.log("SAVED", data)

        }

        function pickNumber(id) {
            $(".tab-pane").removeClass("show");
            $(".tab-pane").removeClass("active");
            $("#" + id).addClass("show");
            $("#" + id).addClass("active");
            $("[name='inPage']").removeAttr("checked");
            $("[name='inModal']").removeAttr("checked");
            $("input#number" + id).attr("checked", "checked");

        }

        function checkUnresolved() {
            var el = $("#unResolved");
            if (notAnswered.length >= 1) {
                el.html("Kamu belum mengerjakan soal nomor " + notAnswered.join(","));
                el.removeClass("d-none");
            } else {
                el.html("");
                el.addClass("d-none");
            }
        }

        function endedSession(data) {
            if (data['redirect']) {
                window.location = data['redirect'];
            } else {
                window.location.reload();
            }
        }

        $(document).ready(function () {

            $(document).on('click', 'a#finishSession', function (e) {
                var uri = "{{ path('end_quiz_session', {cat: ref, reg: reg} ) }}";
                ajaxCall("endedSession", uri, "POST", true)
            });

            $(document).on('click', 'a.answer', function (e) {
                e.preventDefault();
                var Q = $(this).data("q");
                var n = $(this).data("n");
                var QA = $(this).data("qa");
                let uri = "{{ path("save_answer_quiz", {cat: ref, reg: reg}) }}";
                $("a#number" + n).removeAttr("style");
                notAnswered.remove(n);
                checkUnresolved();
                $(this).attr("style", "background-color:var(--primaryColor)");
                ajaxCall("saveSuccess", uri, "POST", false, {Q: Q, QA: QA})
            });
        });


        function fetchData(data) {
            let numberInPageHtml = '';
            let numberInModalHtml = '';
            var uriReport = "{{ path('laporkanSoal', {quiz : 'zen', reg:reg}) }}";
            data.forEach(function (data, key) {
                let answer = parseInt(data['answer']);


                if (key === 0) {
                    asuTime = stringToDate((data['startedAt']));

                    interValCountDown = setInterval(function () {
                        makeTimer(data['tryOut']['duration']);
                    }, 1000);
                    $("#bottomBar").removeClass("d-none");
                }
                data = data[0];
                var number = key + 1;


                if (isNaN(answer)) {
                    notAnswered.push(number);
                    checkUnresolved();
                }
                if (number <= 7) {
                    numberInPageHtml += '<div onclick="pickNumber(' + number + ')" class="d-inline-block">\n' +
                        '                            <input id="number' + number + '" class="checkbox-jam" id="pickNumber" type="radio" name="inPage" ' + (key === 0 ? 'checked' : '') + ' value="' + number + '">\n' +
                        '                            <label class="for-checkbox-tab " style="padding: 0.6em 1em;" for="inPage' + number + '">\n' +
                        '                                <p class="mb-0 font-weight-bold p-0 f06">' + number + '</p>\n' +
                        '                            </label>\n' +
                        '                        </div>\n';
                }

                numberInModalHtml += '<div onclick="pickNumber(' + number + ')" class="d-inline-block">\n' +
                    '                            <input id="number' + number + '" class="checkbox-jam" id="pickNumber" type="radio" name="inModal" ' + (key === 0 ? 'checked' : '') + ' value="' + number + '">\n' +
                    '                            <label class="for-checkbox-tab " style="padding: 0.6em 1em;" for="inModal' + number + '">\n' +
                    '                                <p class="mb-0 font-weight-bold p-0 f06">' + number + '</p>\n' +
                    '                            </label>\n' +
                    '                        </div>\n'

                $("#title-bar").html(data['tryOut']['subject']['name']);

                let optionsHtmll = "";
                let uriReport1 = uriReport;
                uriReport1 = uriReport1.replace("zen", data['id']);
                data['options'].forEach(function (option, key) {
                    optionsHtmll += option['option'] !== "" ? '' +
                        '   <a ' + (answer === key ? ' style="background-color:var(--primaryColor)" ' : '') + 'id="number' + number + '" data-N="' + number + '" data-Q="' + data['id'] + '" data-QA="' + key + '"  class="answer d-flex  p-2 align-items-center text-black-50 gen-card " href="#">\n' +
                        '            <p class="mb-0">' + option['option'] + '</p>\n' +
                        '        </a>\n' : "";
                });
                $("#content").append(' <div class="tab-pane fade col-12 mt-4 ' + (key === 0 ? 'show active' : '') + '" id="' + (key + 1) + '" role="tabpanel"\n' +
                    '                 aria-labelledby="sma-tab">\n' +
                    ' <div class="gen-card p-3">\n' +
                    data['question'] +
                    '            <div class="d-flex justify-content-end">\n' +
                    '                <a class="d-flex p-1 align-items-center text-black-50 w-50"\n' +
                    '                   style="border: 1px solid grey; border-radius: 50px" href="' + uriReport1 + '">\n' +
                    '                    <i class="mdi mdi-info mr-2 f14"></i>\n' +
                    '                    <p class="mb-0 f08">Laporkan Soal</p>\n' +
                    '                </a>\n' +
                    '            </div>\n' +
                    '        </div>\n' + optionsHtmll +
                    '            </div>'
                );
            });

            $("#numberInPage").html(numberInPageHtml);
            $("#numberInModal").html(numberInModalHtml);

            function makeTimer(asu) {

                endTime = new Date(asuTime.getTime() + (asu * 60000));

                endTime = (Date.parse(endTime) / 1000);

                var now = new Date();

                now = (Date.parse(now) / 1000);

                var timeLeft = endTime - now;

                var days = Math.floor(timeLeft / 86400);
                var hours = Math.floor((timeLeft - (days * 86400)) / 3600);
                var minutes = Math.floor((timeLeft - (days * 86400) - (hours * 3600)) / 60);
                var seconds = Math.floor((timeLeft - (days * 86400) - (hours * 3600) - (minutes * 60)));


                if (isNaN(hours) && isNaN(minutes) && isNaN(minutes) && isNaN(seconds) || days < 0) {
                    timeOut = true;
                    $("#kumpulkan").remove();
                    clearInterval(interValCountDown);
                    alert("Waktu Habis");
                    window.history.back();
                }else {
                    if (hours < "10") {
                        hours = "0" + hours;
                    }
                    if (minutes < "10") {
                        minutes = "0" + minutes;
                    }
                    if (seconds < "10") {
                        seconds = "0" + seconds;
                    }


                    $("span.countdown").html(hours + ":" + minutes + ":" + seconds);
                }

            }

            $("p[data-f-id='pbf']").remove();

        }
    </script>
    {{ f.ajaxCall("fetchData", path("get_all_quizes", {cat : ref, reg:reg}), "GET") }}


{% endblock %}